using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RFramework;

namespace RFrameGenerate.Model
{
    public partial class T_SA_StoreCoupons : EntityBase<T_SA_StoreCoupons>, ICloneable
    {
        public Guid StoreCouponsGuid{ get;set; }
        public Guid? StoreActivityGuid{ get;set; }   
        public decimal? Amount{ get;set; }   
        public int? EachNum{ get;set; }   
        public int? ReceivedNum{ get;set; }   
        public int? TotalNum{ get;set; }   
        public int? ServiceConditions{ get;set; }   
        public decimal? ServiceConditionsMoney{ get;set; }   
        public int? ValidityType{ get;set; }   
        public int? ValidityDays{ get;set; }   
        public DateTime? ValidityStartDate{ get;set; }   
        public DateTime? ValidityEndDate{ get;set; }   
        public Guid? SMerchantGuid{ get;set; }   
        public bool? IsLimit{ get;set; }   
        
        public override string ToString()
        {
            StringBuilder sb = this.EntityToGetKeyValue();
            if (sb == null)
                return base.ToString();
            else
            {
                return sb.ToString();
            }
        }
        
        #region 创建副本
        /// <summary>
        /// 创建当前 System.Object 的浅表副本
        /// </summary>
        /// <returns>返回当前实例的浅表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public object Clone()
        {
            return this.MemberwiseClone();
        }
        /// <summary>
        /// 创建当前 System.Object 的深表副本
        /// </summary>
        /// <returns>返回当前实例的深表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public T_SA_StoreCoupons DeepClone()
        {
            using (System.IO.Stream objectStream = new System.IO.MemoryStream())
            {
                System.Runtime.Serialization.IFormatter formatter = new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
                formatter.Serialize(objectStream, this);
                objectStream.Seek(0, System.IO.SeekOrigin.Begin);
                return formatter.Deserialize(objectStream) as T_SA_StoreCoupons;
            }
        }
        /// <summary>
        /// 创建当前 System.Object 的浅表副本
        /// </summary>
        /// <returns>返回当前实例的浅表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public T_SA_StoreCoupons ShallowClone()
        {
            return Clone() as T_SA_StoreCoupons;
        }
        #endregion
        
        #region 实体相互转换
        protected override T_SA_StoreCoupons CurrentEntity()
        {
            return this;
        }
        #endregion
    }
}

